{$i compile.inc}
unit ioports;

interface

function inp(port_hi, port_lo:Byte):Byte;
procedure outp(portnum:word;val:Byte);

implementation uses DOS,Core,Vars,SNDDrv,Tape,trdos;

function inp(port_hi, port_lo:Byte):Byte;
var i,data: byte;
begin
     if (sram[0]=TRDOSROM) and (port_lo and 31>0) then
      begin
        i:=(port_lo shr 4) and $e;
        if i<8 then diskvg(i,data) else
        if i=$E then diskvg(8,data);
        inp:=data;exit;
      end;
        case port_lo of
                  31: inp:=StickValue; (* Kempston *)
                 253: (* Ay-3-8912 *) inp:=PSG[last_fffd];
                 254: (* Keys *)
                    begin
                        data:=255;
                        if port_hi and 128=0 then
                                data:=data and SKey[7];
                        if port_hi and 64=0 then
                                data:=data and SKey[6];
                        if port_hi and 32=0 then
                                data:=data and SKey[5];
                        if port_hi and 16=0 then
                                data:=data and SKey[4];
                        if port_hi and 8=0 then
                                data:=data and SKey[3];
                        if port_hi and 4=0 then
                                data:=data and SKey[2];
                        if port_hi and 2=0 then
                                data:=data and SKey[1];
                        if port_hi and 1=0 then
                                data:=data and SKey[0];
                        {if (VOC_file_open) and (VOC_paused=false) then
                            data:=data xor return_next_bit;}

                        inp:=data;
                       end;
                 255: (* Vertical Retrace (not on +3 or +2A) *)
                      inp:=vline and 255; (* Temporary  *)
                else inp:=255; (* Temporary *)
        end;
end;

procedure outp(portnum:word;val:Byte);
var btemp,port_hi,port_lo:Byte;
begin
  port_hi:=(portnum shr 8) and $FF;
  port_lo:=(portnum and $FF);

  if (sram[0]=TRDOSROM) and (port_lo and 31>0) then
   begin
    btemp:=(port_lo shr 4);
    if btemp<8 then diskvg(btemp,val) else
    if btemp=$F then diskvg(9,val);
   end;

  if (port_lo and 1)=0 then border:=val and 7;(* ULA (border/48K sound) *)

  if (not(odd(portnum))) then
   Begin
    tune48k(((val and 16)=0));exit;
   End;

    if port_lo=253 then
     begin
      btemp:=port_hi shr 6;
      case btemp of
      0,1: if model=mzx48 then sram[0]:=ZX48_ROM else
           begin
            ram_state:=val;
            SRAM[3]:=RAM[ram_state and 7];
            CONTENDED[6]:=ram_state and 4;CONTENDED[7]:=CONTENDED[6];

            if (ram_state and 8)>0 then SP_SCREEN:=RAM[7]
                                  else SP_SCREEN:=RAM[5];

            if (ram_state and 16)>0 then
             case model of
              mPentagon : SRAM[0]:=Pentagon_ROM[1];
              mScorpion : SRAM[0]:=Scorpion_ROM[1];
              mZXPLUS2  : SRAM[0]:=Plus2_ROM[1];
              mZXPlus3  : SRAM[0]:=Plus3_ROM[1];
              mZX128    : SRAM[0]:=ZX128_ROM[1];
             end
            else
             case model of
              mPentagon : SRAM[0]:=Pentagon_ROM[0];
              mScorpion : SRAM[0]:=Scorpion_ROM[0];
              mZXPlus2  : SRAM[0]:=Plus2_ROM[0];
              mZXPlus3  : SRAM[0]:=Plus3_ROM[0];
              mZX128    : SRAM[0]:=ZX128_ROM[0];
             end;

            if ram_state and 32>0 then
            begin
             model:=mZX48;
             SRAM[0]:=ZX48_ROM;
             SRAM[3]:=RAM[0];
             CONTENDED[6]:=0;CONTENDED[7]:=0;
            end;
           end;

        2: if model<>mZX48 then sound.PSGOut(last_fffd,val);
        3: last_fffd:=val and 15;
      end;
     end;
end;

begin
 initnew('IOPORTS');
end.
