{$i compile.inc}
unit z80cpu;

interface uses vars;

procedure set_spectrum_mode(mode:zxmodels);
procedure oneinstr;
procedure z80_decode;
procedure z80_reset;
procedure Start_NMI;

implementation
uses core,crt,{$ifdef vesa} vesamon {$else} z80mon {$endif},tape,SNDDrv,ioports,trdos;

{$i procs.inc}
{$i cbops.inc}
{$i edops.inc}
{$i z80ops.inc}

 procedure Start_NMI;
 var temp:byte;
 begin
  iff2:=iff1;
  iff1:=0;
  halt:=0;
  inc(ir.l);
  push(pc.W);
  pc.W:=102;
  temp:=inp(0,191);
  inc(t_state,11);
 end;

 procedure oneinstr; (* Must be changed !!!! *)
 var b:byte;
 begin
        if halt=0 then
        Begin
         inc(ir.l);
         b:=speekb(pc.W);
         inc(pc.w);
         z80[b];
        end else inc(t_state,4);
 end;

procedure checkTimer;
{ If 0, wait until changes
  If 1, decrement variable  and set that next frame will be drawn
  if >1, decrement variable and set that next frame won't be drawn.}
begin
  if (timerVar<=1) and (frame_skip>1) then dec(frame_skip)
 else
  if timerVar>1 then inc(frame_skip);
 {if timerVar=0 then} while timervar=0 do;
 timervar:=0;
end;

procedure HookTRD;
begin
 if model in [mPentagon,mScorpion] then {TNX Raul}
  begin
   if (pc.w>=$4000) and (sram[0]=TRDOSROM) then
    SRAM[0]:=Pentagon_ROM[byte(ram_state and 16>0)]
   else
    if (pc.w and $ff00=$3d00) and (sram[0]=Pentagon_rom[1]) then
     SRAM[0]:=TRDOSROM;
  end;
end;

procedure z80_decode;
var b,screen_up: Byte;
    line,fps:Word;
begin
screen_up:=0;
{$ifdef debug} resetfps;{$endif}
   repeat
      if (t_state>=t_states_per_line) then
        Begin
                t_state:=t_state-t_states_per_line;
                inc(vline);
                if(vline>=Max_V_line) then
                Begin
                        if usestick then ReadJoyStick;
                        vline:=0;
                        inc(screen_up);
                        if (screen_up>=frame_skip) then screen_up:=0;

                        dec(flash_counter);
                        if flash_counter=0 then
                        Begin
                                flash_counter:=16;
                                flash_status:=not flash_status;
                        end;
                        if iff1>0 then
                        Begin
                                iff2:=iff1;
                                iff1:=0;
                                halt:=0;
                                if speekb(pc.w)=$76 then inc(pc.w);
                                push(pc.w);
                                if im=2 then
                                Begin
                                        pc.W:=wordpeek((ir.h shl 8) or 255);
                                        inc(ir.l);
                                        inc(t_state,19);
                                end
                                else
                                Begin
                                        inc(ir.l);
                                        pc.w:=$38; {Z80[255];}
                                        inc(t_state,13);
                                end;
                        end;
           end;
          if (screen_up=0) and (vline and 192>0) then
           begin
            line:=vline-64;
            if (realspeed) and (line=191) then
            begin
             checktimer;
            end;
            updateline(line);
            inc(t_state,ula_delay);
           end;
        end;

        if halt=0 then
        while (t_state<t_states_per_line) and (halt=0) do
         begin

        (* Check for TRDOS *******************************************)
         HookTRD;
        (* Normal Execution Process ***********************************)
         inc(ir.l);
         b:=SRAM[(pc.w and $C000) shr 14]^[pc.w and $3FFF];
         {speekb(pc.W);}
         inc(pc.w);
         z80[b];
         asm
           cmp realspeed,0
           jz @2
           cmp cpu_delay,0
           jz @2
           mov cx,cpu_delay;
           @1: dec cx;
           jnz @1;
           @2:
          end;
        end else
         z80[0]; {inc(t_state,4);}

    (* Joystick *******************************************************)
    if usestick then {either use keyboard; look into core.pas}
    begin
     stickvalue:=0;
     if JoyAX>JoyMaxX then stickvalue:=stickvalue or $01; {Right}
     if JoyAX<JoyMinX then stickvalue:=stickvalue or $02; {Left}
     if JoyAY>JoyMaxY then stickvalue:=stickvalue or $04; {Down}
     if JoyAY<JoyMinY then stickvalue:=stickvalue or $08; {Up}
     if (joybuttons and $10)=0 then stickvalue:=stickvalue or $10; {Fire}
    end;
   until (key[59]) or (key[60]) or (key[61]) or (key[62]) or (key[63])
         or (key[64]) or (key[65]) or (key[66]) or (key[67]) or (key[68])
         {or (keypressed)};
 sound.mutesound;
end;

procedure z80_reset;
var x:byte;
Begin
        for x:=0 to 15 do PSG[x]:=255;
        iff1:=0;
        iff2:=0;
        bit7_r:=0;
        hl.W:=0;
        de.W:=0;
        bc.W:=0;
        hl2.W:=0;
        de2.W:=0;
        de2.W:=0;
        ix.W:=0;
        iy.W:=0;
        im:=0;
        ir.W:=0;
        sp.W:=0;
        pc.W:=0;
        af.W:=0;af2.W:=0;
        halt:=0;
        last_fffd:=0;
        vline:=0;
        t_state:=0;
        flash_counter:=16;
end;

procedure set_spectrum_mode(mode:ZXModels);
var dummy:byte;
begin
 model:=mode;
 case mode of
  mzx48:
     begin
      max_v_Line:=311;
      t_states_per_line:=228;
      outp(32765,48);
      z80_reset;
     end;
  mZX128:
     begin
      max_v_Line:=311;
      t_states_per_line:=228;{311; {???}
      outp(32765,128);
      z80_reset;
     end;
  mZXPlus2:
     begin
      max_v_Line:=311;
      t_states_per_line:=228;{311; {???}
      outp(32765,128);
      z80_reset;
     end;
  mZXPlus3:
     begin
      max_v_Line:=311;
      t_states_per_line:=228;{311; {???}
      outp(32765,128);
      z80_reset;
     end;

  mPentagon:
     begin
      max_v_Line:=320;
      t_states_per_line:=224;
      outp(32765,128);
      DiskVG($C,dummy);
      z80_reset;
     end;
  mScorpion:
     begin
      max_v_Line:=320;
      t_states_per_line:=224;
      outp(32765,128);
      DiskVG($C,dummy);
      z80_reset;
     end;

 end;
end;

begin
 initNew('Z80-CPU ');
 displaynew('Create CB-Table');createCB;
 displaynew('Create ED-Table');CreateED;
 displaynew('Create Z80-Table');CreateZ80;
end.
