{$i compile.inc}
Unit z80Mon;

Interface


var speccyline: array[0..191] of word;
    reverse_attr:array[0..127] of byte;
    vga_h_nib:array[0..15,0..127] of longint;

procedure updateline(Y:word); {draw each line 0-191}
Procedure Display;            {Paint only the screen}
Procedure RepaintAll;         {Repaint the screen and the Border}
procedure Setpal;             {Set the Speccy-Pal}

const rgb:array[0..16*3-1] of byte=(
 0,0,0,0,0,40,55,0,0,57,0,45,0,53,0,0,53,53,52,52,0,50,50,50,
 0,0,0,0,0,43,60,0,0,63,0,55,0,60,0,0,63,63,63,63,0,63,63,63);
 { PURPUR,      WEISS,   SCHWARZ,    CYAN}
 menucol:array[0..14] of byte=
 (115,115,115,165,165,240,255,255,255,10,10,20,67,255,255);

const oldborder:Byte=255;
      flash_status:Boolean=False;

Implementation
uses dos,core,vars;

procedure setpal;
var i: longint;
begin
 port[$3c8]:=0;for i:=0 to 16*3-1 do port[$3c9]:=rgb[i];
 port[$3c8]:=116;for i:=0 to 14 do port[$3c9]:=menucol[i];
 asm
   mov edi,$a0000
   mov ecx,64000/4
   mov eax,$FFFFFFFF
   rep stosd
 end;
end;

procedure make_table;
var  v,x,y,z:integer;
     fore_attrib,back_attrib:array[0..255] of byte;
     qtemp:Quadruple;
begin
 v:=0;
 for x:=0 to 2 do
   for y:=0 to 7 do
     for z:=0 to 7 do
      begin
       speccyline[v]:=x shl 11+y shl 5+z shl 8;
       inc(v);
      end;
 for x:=0 to 255 do
  begin
   y:=x and 7; (* fore *)
   z:=(x and 56) shr 3; (* back *)
   if y=0 then y:=y or 8;
   if z=0 then z:=z or 8;
		if x and 64>0 then
		begin
			y:=y or 8;
			z:=z or 8;
		end;
		fore_attrib[x]:=y;
		back_attrib[x]:=z;
	end;

	for x:=0 to 15 do
	begin
		for y:=0 to 127 do
		begin
			if x and 1>0 then

				qtemp.b4:=fore_attrib[y]
			else
				qtemp.b4:=back_attrib[y];
			if x and 2>0 then
				qtemp.b3:=fore_attrib[y]
			else
				qtemp.b3:=back_attrib[y];

			if x and 4>0 then
				qtemp.b2:=fore_attrib[y]
			else
				qtemp.b2:=back_attrib[y];
			if x and 8>0 then
				qtemp.b1:=fore_attrib[y]
			else
				qtemp.b1:=back_attrib[y];
			vga_h_nib[x][y]:=qtemp.Q;
		end;
	end;
	for x:=0 to 127 do
	begin
		y:=(x and 7) shr 3;
		z:=(x and 56) shr 3;
		reverse_attr[x]:=(x and 64) or y or z;
	end;

end;

procedure updateline(Y:word);
var bitmap, farbepos:word;offs:longint;
     x, color, attr, data:Byte;
begin
	{$ifdef debug} if y=191 then nextframe;{$endif}
        {$ifdef realborder}
         offs:=$a0000+(y)*320;
         for x:=0 to 31 do
          begin mem[offs+x]:=border;
                mem[offs+319-x]:=border;
          end;
         inc(offs,32);
        {$else}
         offs:=$a0000+(y+4)*320+32;
        {$endif}
         if oldborder<>border then
         begin
          oldborder:=border;
          {$ifndef realborder}
           port[$3c8]:=255;x:=border*3;
           port[$3c9]:=rgb[x];
           port[$3c9]:=rgb[x+1];
           port[$3c9]:=rgb[x+2];
          {$endif}
        end;

	bitmap:=speccyline[y];
	farbepos:=6144 or ((y and 248) shl 2);
        for x:=0 to 31 do
         begin
          color:=sp_SCREEN^[farbepos];inc(farbepos);
          asm
           mov al,color
           and al,127
           mov attr,al
          end;
  	  if (color and 128>0) and (flash_status) then
           attr:=reverse_attr[attr];

 	  data:=SP_SCREEN^[bitmap];inc(bitmap);

          meml[offs]:=vga_h_nib[(data and $F0) shr 4][attr];inc(offs,4);
          meml[offs]:=vga_h_nib[data and $0F][attr];inc(offs,4);

         end;
 end;


Procedure Display;
Var Y: Byte;
begin
 for y:=0 to 191 do updateline(y);
end;

Procedure RepaintAll;
var i:word;
begin
 asm
   mov edi,$a0000
   mov ecx,64000/4
   mov eax,$FFFFFFFF
   rep stosd
 end;
 Display;
end;

begin
 initnew('Spectrum Display Unit');
 displaynew('Creating Tables');
 make_table;
end.
